详解Java异常处理中finally子句的运用


当异常被抛出,通常方法的执行将作一个陡峭的非线性的转向。依赖于方法是怎样编码的,异常甚至可以导致方法过早返回。这在一些方法中是一个问题。例如,如果一个方法打开一个文件项并关闭,然后退出,你不希望关闭文件的代码被异常处理机制旁路。finally关键字为处理这种意外而设计。

finally创建一个代码块。该代码块在一个try/catch 块完成之后另一个try/catch出现之前执行。finally块无论有没有异常抛出都会执行。如果异常被抛出,finally甚至是在没有与该异常相匹配的catch子句情况下也将执行。一个方法将从一个try/catch块返回到调用程序的任何时候,经过一个未捕获的异常或者是一个明确的返回语句,finally子句在方法返回之前仍将执行。这在关闭文件句柄和释放任何在方法开始时被分配的其他资源是很有用的。finally子句是可选项,可以有也可以无。然而每一个try语句至少需要一个catch或finally子句。

下面的例子显示了3种不同的退出方法。每一个都执行了finally子句:

// Demonstrate finally.
class FinallyDemo {
  // Through an exception out of the method.
  static void procA() {
    try {
      System.out.println("inside procA");
      throw new RuntimeException("demo");
    } finally {
      System.out.println("procA's finally");
    }
  }

  // Return from within a try block.
  static void procB() {
    try {
      System.out.println("inside procB");
      return;
    } finally {
      System.out.println("procB's finally");
    }
  }
  // Execute a try block normally.
  static void procC() {
    try {
      System.out.println("inside procC");
    } finally {
      System.out.println("procC's finally");
    }
  }

  public static void main(String args[]) {
    try {
     procA();
    } catch (Exception e) {
     System.out.println("Exception caught");
    }
    procB();
    procC();
  }
}

该例中,procA( )过早地通过抛出一个异常中断了try。Finally子句在退出时执行。procB( )的try语句通过一个return语句退出。在procB( )返回之前finally子句执行。在procC()中,try语句正常执行,没有错误。然而,finally块仍将执行。

注意:如果finally块与一个try联合使用,finally块将在try结束之前执行。

下面是上述程序产生的输出:

inside procA
procA's finally
Exception caught
inside procB
procB's finally
inside procC
procC's finally



相关阅读:
jquery无法设置checkbox选中即没有变成选中状态
jQuery获取字符串中出现最多的数
JS实现仿百度输入框自动匹配功能的示例代码
Jquery获取和修改img的src值的方法
javascript引擎长时间独占线程造成卡顿的解决方案
Json数据解析模拟美团界面显示
nodeType属性返回被选节点的节点类型介绍
Android 游戏开发之Canvas画布的介绍及方法
360浏览器文本框获得焦点后被android软键盘遮罩该怎么办
HTML (css样式规范)必看篇
Java生成非对称型加密公钥和私钥的方法
C++中const用法小结
ASP.NET MVC5网站开发我的咨询列表及添加咨询(十二)
AngularJS入门知识之MVW类框架的编程思想探讨
快速导航

Copyright © 2016 phpStudy | 皖ICP备18014864号-4